2005-07-24 18:16:26 +00:00
#! /bin/sh
# Install GRUB on your drive.
2010-09-08 21:41:27 +00:00
# Copyright (C) 1999,2000,2001,2002,2003,2004,2005,2006,2007,2008,2009,2010 Free Software Foundation, Inc.
2005-07-24 18:16:26 +00:00
#
2007-07-21 23:32:33 +00:00
# GRUB is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
2005-07-24 18:16:26 +00:00
# (at your option) any later version.
#
2007-07-21 23:32:33 +00:00
# GRUB is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
2005-07-24 18:16:26 +00:00
#
# You should have received a copy of the GNU General Public License
2007-07-21 23:32:33 +00:00
# along with GRUB. If not, see <http://www.gnu.org/licenses/>.
2005-07-24 18:16:26 +00:00
# Initialize some variables.
2007-04-10 21:38:26 +00:00
transform="@program_transform_name@"
2005-07-24 18:16:26 +00:00
prefix=@prefix@
exec_prefix=@exec_prefix@
sbindir=@sbindir@
2006-05-19 11:22:47 +00:00
bindir=@bindir@
2006-05-08 19:29:10 +00:00
libdir=@libdir@
2010-08-30 19:00:48 +00:00
sysconfdir=@sysconfdir@
2005-07-24 18:16:26 +00:00
PACKAGE_NAME=@PACKAGE_NAME@
PACKAGE_TARNAME=@PACKAGE_TARNAME@
PACKAGE_VERSION=@PACKAGE_VERSION@
2006-05-29 Yoshinori K. Okuji <okuji@enbug.org>
* util/powerpc/ieee1275/grub-install.in (host_cpu): Removed.
(target_cpu): New variable.
(pkglibdir): Use target_cpu instead of host_cpu.
* util/i386/pc/grub-install.in (host_cpu): Removed.
(target_cpu): New variable.
(pkglibdir): Use target_cpu instead of host_cpu.
* util/genmoddep.c: Removed.
* kern/efi/mm.c (filter_memory_map): Use GRUB_CPU_SIZEOF_VOID_P
instead of GRUB_HOST_SIZEOF_VOID_P.
* kern/dl.c: Likewise.
* include/grub/i386/types.h (GRUB_HOST_SIZEOF_VOID_P): Renamed to
...
(GRUB_TARGET_SIZEOF_VOID_P): ... this.
(GRUB_HOST_SIZEOF_LONG): Renamed to ...
(GRUB_TARGET_SIZEOF_LONG): ... this.
(GRUB_HOST_WORDS_BIGENDIAN): Renamed to ...
(GRUB_TARGET_WORDS_BIGENDIAN): ... this.
* include/grub/powerpc/types.h (GRUB_HOST_SIZEOF_VOID_P): Renamed
to ...
(GRUB_TARGET_SIZEOF_VOID_P): ... this.
(GRUB_HOST_SIZEOF_LONG): Renamed to ...
(GRUB_TARGET_SIZEOF_LONG): ... this.
(GRUB_HOST_WORDS_BIGENDIAN): Renamed to ...
(GRUB_TARGET_WORDS_BIGENDIAN): ... this.
* include/grub/sparc64/types.h (GRUB_HOST_SIZEOF_VOID_P): Renamed
to ...
(GRUB_TARGET_SIZEOF_VOID_P): ... this.
(GRUB_HOST_SIZEOF_LONG): Renamed to ...
(GRUB_TARGET_SIZEOF_LONG): ... this.
(GRUB_HOST_WORDS_BIGENDIAN): Renamed to ...
(GRUB_TARGET_WORDS_BIGENDIAN): ... this.
* include/grub/types.h [!GRUB_UTIL] (GRUB_CPU_SIZEOF_VOID_P): Use
GRUB_TARGET_SIZEOF_VOID_P instead of GRUB_HOST_SIZEOF_VOID_P.
[!GRUB_UTIL] (GRUB_CPU_SIZEOF_LONG): Use GRUB_TARGET_SIZEOF_LONG
instead of GRUB_HOST_SIZEOF_LONG.
[!GRUB_UTIL]: Refer to GRUB_TARGET_WORDS_BIGENDIAN instead of
GRUB_HOST_WORDS_BIGENDIAN to define or undefine
GRUB_CPU_WORDS_BIGENDIAN.
Refer to SIZEOF_VOID_P instead of GRUB_HOST_SIZEOF_VOID_P to
define grub_host_addr_t, grub_host_off_t, grub_host_size_t and
grub_host_ssize_t.
* conf/i386-efi.rmk (noinst_UTILITIES): Removed.
(genmoddep_SOURCES): Likewise.
* conf/i386-pc.rmk (noinst_UTILITIES): Likewise.
(genmoddep_SOURCES): Likewise.
* conf/conf/powerpc-ieee1275.rmk (noinst_UTILITIES): Likewise.
(genmoddep_SOURCES): Likewise.
* conf/conf/conf/sparc64-ieee1275.rmk (noinst_UTILITIES):
Likewise.
(genmoddep_SOURCES): Likewise.
* genmoddep.awk: New file.
* genmk.rb (Image::rule): Use TARGET_CC, TARGET_CPPFLAGS,
TARGET_CFLAGS, TARGET_ASFLAGS and TARGET_LDFLAGS instead of CC,
CPPFLAGS, CFLAGS, ASFLAGS and LDFLAGS, respectively.
(PModule::rule): Likewise.
(Program::rule): Likewise.
(Utility::rule): Use CC, CPPFLAGS, CFLAGS and LDFLAGS instead of
BUILD_CC, BUILD_CPPFLAGS, BUILD_CFLAGS and BUILD_LDFLAGS,
respectively.
* configure.ac: Rewritten intensively to use host and target
instead of build and host, respectively.
* Makefile.in (pkglibdir): Use target_cpu instead of host_cpu.
(host_cpu): Removed.
(target_cpu): New variable.
(CPPFLAGS): Added @CPPFLAGS@ and -DGRUB_LIBDIR=\"$(pkglibdir)\".
(BUILD_CC): Removed.
(BUILD_CFLAGS): Likewise.
(BUILD_CPPFLAGS): Likewise.
(TARGET_CC): New variable.
(TARGET_CFLAGS): Likewise.
(TARGET_CPPFLAGS): Likewise.
(TARGET_LDFLAGS): Likewise.
(AWK): Likewise.
(include): Use target_cpu instead of host_cpu.
(moddep.lst:): Use genmoddep.awk instead of genmoddep.
* DISTLIST: Added genmoddep.awk. Removed util/genmoddep.c.
2006-05-28 23:01:43 +00:00
target_cpu=@target_cpu@
2006-05-08 19:29:10 +00:00
platform=@platform@
2009-12-24 22:23:22 +00:00
host_os=@host_os@
2007-04-10 21:38:26 +00:00
pkglibdir=${libdir}/`echo ${PACKAGE_TARNAME}/${target_cpu}-${platform} | sed ${transform}`
2010-03-21 23:04:02 +00:00
localedir=@datadir@/locale
2005-07-24 18:16:26 +00:00
2010-06-08 10:52:42 +00:00
self=`basename $0`
2007-04-10 21:38:26 +00:00
grub_setup=${sbindir}/`echo grub-setup | sed ${transform}`
2010-04-26 19:27:41 +00:00
grub_mkimage=${bindir}/`echo grub-mkimage | sed ${transform}`
2007-04-10 21:38:26 +00:00
grub_mkdevicemap=${sbindir}/`echo grub-mkdevicemap | sed ${transform}`
grub_probe=${sbindir}/`echo grub-probe | sed ${transform}`
2009-11-20 08:41:20 +00:00
grub_editenv=${bindir}/`echo grub-editenv | sed ${transform}`
2010-08-30 17:30:34 +00:00
grub_mkrelpath=${bindir}/`echo grub-mkrelpath | sed ${transform}`
2005-07-24 18:16:26 +00:00
rootdir=
2010-09-08 15:25:29 +00:00
bootdir=
grubdir=`echo "/@bootdirname@/@grubdirname@" | sed 's,//*,/,g'`
2005-08-07 14:59:56 +00:00
modules=
2005-07-24 18:16:26 +00:00
install_device=
no_floppy=
force_lba=
recheck=no
debug=no
2010-06-28 08:06:41 +00:00
debug_image=
2005-07-24 18:16:26 +00:00
2010-08-30 17:30:34 +00:00
update_nvram=yes
ofpathname=`which ofpathname`
nvsetenv=`which nvsetenv`
2010-08-30 19:00:48 +00:00
efibootmgr=`which efibootmgr 2>/dev/null || true`
removable=no
efi_quiet=
2010-08-30 17:30:34 +00:00
2010-09-11 14:37:00 +00:00
# Get GRUB_DISTRIBUTOR.
if test -f ${sysconfdir}/default/grub ; then
. ${sysconfdir}/default/grub
fi
bootloader_id="$(echo "$GRUB_DISTRIBUTOR" | tr '[A-Z]' '[a-z]' | cut -d' ' -f1)"
if test -z "$bootloader_id"; then
bootloader_id=grub
fi
2009-06-08 20:51:16 +00:00
if [ "${target_cpu}-${platform}" = "i386-pc" ] ; then
disk_module=biosdisk
2010-09-06 21:03:25 +00:00
elif [ "${platform}" = "ieee1275" ] || [ "${platform}" = "efi" ] ; then
2009-11-22 11:22:19 +00:00
disk_module=
2009-06-08 20:51:16 +00:00
else
disk_module=ata
fi
2005-07-24 18:16:26 +00:00
# Usage: usage
# Print the usage.
usage () {
2010-08-30 17:30:34 +00:00
if test "x$install_device" = x && test "${target_cpu}-${platform}" != "mips-yeeloong" && test "${target_cpu}-${platform}" != "i386-ieee1275" && test "${target_cpu}-${platform}" != "powerpc-ieee1275"; then
2005-07-24 18:16:26 +00:00
cat <<EOF
2010-06-08 10:52:42 +00:00
Usage: $self [OPTION] install_device
2010-08-30 17:30:34 +00:00
EOF
else
cat <<EOF
Usage: $self [OPTION] [install_device]
EOF
fi
cat <<EOF
2005-07-24 18:16:26 +00:00
Install GRUB on your drive.
-h, --help print this message and exit
-v, --version print the version information and exit
2005-08-07 14:59:56 +00:00
--modules=MODULES pre-load specified modules MODULES
2010-09-08 15:25:29 +00:00
--boot-directory=DIR install GRUB images under the directory DIR/@grubdirname@
instead of the $grubdir directory
2005-07-24 18:16:26 +00:00
--grub-setup=FILE use FILE as grub-setup
--grub-mkimage=FILE use FILE as grub-mkimage
2010-08-30 17:30:34 +00:00
--grub-mkrelpath=FILE use FILE as grub-mkrelpath
2005-07-24 18:16:26 +00:00
--grub-mkdevicemap=FILE use FILE as grub-mkdevicemap
2006-10-14 18:59:34 +00:00
--grub-probe=FILE use FILE as grub-probe
2005-07-24 18:16:26 +00:00
--no-floppy do not probe any floppy drive
--recheck probe a device map even if it already exists
2009-05-04 16:16:03 +00:00
--force install even if problems are detected
2009-06-08 20:51:16 +00:00
EOF
if [ "${target_cpu}-${platform}" = "i386-pc" ] ; then
cat <<EOF
--disk-module=MODULE disk module to use
EOF
2009-12-09 18:39:21 +00:00
fi
2010-08-30 17:30:34 +00:00
if [ "${target_cpu}-${platform}" = "i386-ieee1275" ] || [ "${target_cpu}-${platform}" = "powerpc-ieee1275" ] ; then
cat <<EOF
--no-nvram don't update the boot-device NVRAM variable
EOF
2010-08-30 19:00:48 +00:00
fi
if [ "${platform}" = "efi" ]; then
cat <<EOF
--removable the installation device is removable
2010-09-11 14:37:00 +00:00
--bootloader-id=ID the ID of bootloader.
2010-08-30 19:00:48 +00:00
EOF
2009-06-08 20:51:16 +00:00
fi
cat <<EOF
2005-07-24 18:16:26 +00:00
INSTALL_DEVICE can be a GRUB device name or a system device filename.
2010-09-08 15:25:29 +00:00
$self copies GRUB images into $grubdir, and uses grub-setup
to install grub into the boot sector.
2005-07-24 18:16:26 +00:00
Report bugs to <bug-grub@gnu.org>.
EOF
}
2010-04-12 16:03:03 +00:00
argument () {
opt=$1
shift
if test $# -eq 0; then
echo "$0: option requires an argument -- '$opt'" 1>&2
exit 1
fi
echo $1
}
2005-07-24 18:16:26 +00:00
# Check the arguments.
2010-02-06 08:59:42 +00:00
while test $# -gt 0
do
option=$1
shift
2005-07-24 18:16:26 +00:00
case "$option" in
-h | --help)
usage
exit 0 ;;
-v | --version)
2010-06-08 10:52:42 +00:00
echo "$self (${PACKAGE_NAME}) ${PACKAGE_VERSION}"
2005-07-24 18:16:26 +00:00
exit 0 ;;
2010-02-06 08:59:42 +00:00
--modules)
2010-04-12 16:03:03 +00:00
modules=`argument $option "$@"`; shift;;
2005-08-07 14:59:56 +00:00
--modules=*)
modules=`echo "$option" | sed 's/--modules=//'` ;;
2010-02-06 08:59:42 +00:00
2010-08-30 17:48:10 +00:00
# Accept and ignore for compatibility
2010-02-06 08:59:42 +00:00
--font)
2010-08-30 17:48:10 +00:00
shift;;
2009-12-09 18:39:21 +00:00
--font=*)
2010-08-30 17:48:10 +00:00
;;
2010-02-06 08:59:42 +00:00
2010-09-08 15:25:29 +00:00
# Accept for compatibility
2010-02-06 08:59:42 +00:00
--root-directory)
2010-04-12 16:03:03 +00:00
rootdir=`argument $option "$@"`; shift;;
2005-07-24 18:16:26 +00:00
--root-directory=*)
rootdir=`echo "$option" | sed 's/--root-directory=//'` ;;
2010-02-06 08:59:42 +00:00
2010-09-08 15:25:29 +00:00
--boot-directory)
bootdir=`argument $option "$@"`; shift;;
--boot-directory=*)
bootdir=`echo "$option" | sed 's/--boot-directory=//'` ;;
2010-02-06 08:59:42 +00:00
--grub-setup)
2010-04-12 16:03:03 +00:00
grub_setup=`argument $option "$@"`; shift;;
2005-07-24 18:16:26 +00:00
--grub-setup=*)
grub_setup=`echo "$option" | sed 's/--grub-setup=//'` ;;
2010-02-06 08:59:42 +00:00
2010-09-11 14:37:00 +00:00
--bootloader-id)
bootloader_id=`argument $option "$@"`; shift;;
--bootloader_id=*)
bootloader_id=`echo "$option" | sed 's/--bootloader_id=//'` ;;
2010-02-06 08:59:42 +00:00
--grub-mkimage)
2010-04-12 16:03:03 +00:00
grub_mkimage=`argument $option "$@"`; shift;;
2005-07-24 18:16:26 +00:00
--grub-mkimage=*)
grub_mkimage=`echo "$option" | sed 's/--grub-mkimage=//'` ;;
2010-02-06 08:59:42 +00:00
2010-08-30 17:30:34 +00:00
--grub-mkrelpath)
grub_mkrelpath=`argument $option "$@"`; shift;;
--grub-mkimage=*)
grub_mkrelpath=`echo "$option" | sed 's/--grub-mkrelpath=//'` ;;
2010-02-06 08:59:42 +00:00
--grub-mkdevicemap)
2010-04-12 16:03:03 +00:00
grub_mkdevicemap=`argument $option "$@"`; shift;;
2005-07-24 18:16:26 +00:00
--grub-mkdevicemap=*)
2005-08-07 14:59:56 +00:00
grub_mkdevicemap=`echo "$option" | sed 's/--grub-mkdevicemap=//'` ;;
2010-02-06 08:59:42 +00:00
--grub-probe)
2010-04-12 16:03:03 +00:00
grub_probe=`argument $option "$@"`; shift;;
2006-10-14 18:59:34 +00:00
--grub-probe=*)
grub_probe=`echo "$option" | sed 's/--grub-probe=//'` ;;
2010-02-06 08:59:42 +00:00
2005-07-24 18:16:26 +00:00
--no-floppy)
no_floppy="--no-floppy" ;;
--recheck)
recheck=yes ;;
2010-08-30 19:00:48 +00:00
--removable)
removable=yes ;;
2010-02-06 08:59:42 +00:00
--disk-module)
if [ "${target_cpu}-${platform}" = "i386-pc" ] ; then
2010-04-12 16:03:03 +00:00
disk_module=`argument $option "$@"`; shift;
2010-02-06 08:59:42 +00:00
fi ;;
2009-06-08 20:51:16 +00:00
--disk-module=*)
if [ "${target_cpu}-${platform}" = "i386-pc" ] ; then
2009-07-28 18:32:28 +00:00
disk_module=`echo "$option" | sed 's/--disk-module=//'`
2009-06-08 20:51:16 +00:00
fi ;;
2010-02-06 08:59:42 +00:00
2010-08-30 17:30:34 +00:00
--no-nvram)
update_nvram=no ;;
2005-07-24 18:16:26 +00:00
# This is an undocumented feature...
--debug)
debug=yes ;;
2010-06-28 08:06:41 +00:00
--debug-image)
debug_image=`argument $option "$@"`; shift;;
--debug-image=*)
debug_image=`echo "$option" | sed 's/--debug-image=//'` ;;
2009-05-04 16:16:03 +00:00
-f | --force)
setup_force="--force" ;;
2010-02-06 08:59:42 +00:00
2005-07-24 18:16:26 +00:00
-*)
echo "Unrecognized option \`$option'" 1>&2
usage
exit 1
;;
*)
if test "x$install_device" != x; then
echo "More than one install_devices?" 1>&2
usage
exit 1
fi
install_device="${option}" ;;
esac
done
2009-11-11 16:00:27 +00:00
# for make_system_path_relative_to_its_root()
. ${libdir}/grub/grub-mkconfig_lib
2010-08-30 17:30:34 +00:00
if test "x$install_device" = x && test "${target_cpu}-${platform}" != "mips-yeeloong" && test "${target_cpu}-${platform}" != "i386-ieee1275" && test "${target_cpu}-${platform}" != "powerpc-ieee1275"; then
2005-07-24 18:16:26 +00:00
echo "install_device not specified." 1>&2
usage
exit 1
fi
# If the debugging feature is enabled, print commands.
2008-07-24 19:02:47 +00:00
setup_verbose=
2005-07-24 18:16:26 +00:00
if test $debug = yes; then
set -x
2008-07-24 19:02:47 +00:00
setup_verbose="--verbose"
2010-08-30 19:00:48 +00:00
efi_quiet=-q
2005-07-24 18:16:26 +00:00
fi
2010-09-08 15:25:29 +00:00
if [ -z "$bootdir" ]; then
# Default bootdir if bootdir not initialized.
bootdir=/@bootdirname@
2005-07-24 18:16:26 +00:00
2010-09-08 15:25:29 +00:00
if [ -n "$rootdir" ] ; then
# Initialize bootdir if rootdir was initialized.
bootdir=${rootdir}/@bootdirname@
fi
fi
2005-07-24 18:16:26 +00:00
2010-09-08 15:25:29 +00:00
grubdir=`echo "${bootdir}/@grubdirname@" | sed 's,//*,/,g'`
device_map=${grubdir}/device.map
2008-06-06 15:49:23 +00:00
grub_probe="${grub_probe} --device-map=${device_map}"
2005-07-24 18:16:26 +00:00
# Check if GRUB is installed.
2009-11-25 21:34:35 +00:00
if [ "${target_cpu}-${platform}" = "i386-pc" ] || [ "${target_cpu}-${platform}" = "sparc64-ieee1275" ] ; then
2008-11-28 20:06:55 +00:00
set $grub_setup dummy
if test -f "$1"; then
:
else
echo "$1: Not found." 1>&2
exit 1
fi
2005-07-24 18:16:26 +00:00
fi
set $grub_mkimage dummy
if test -f "$1"; then
:
else
echo "$1: Not found." 1>&2
exit 1
fi
set $grub_mkdevicemap dummy
if test -f "$1"; then
:
else
echo "$1: Not found." 1>&2
exit 1
fi
2010-09-08 11:54:38 +00:00
if [ x"$platform" = xefi ]; then
# Find the EFI System Partition.
efidir=
if test -d ${bootdir}/efi; then
install_device=`$grub_mkdevicemap --device-map=/dev/stdout | $grub_probe --target=device --device-map=/dev/stdin ${bootdir}/efi`
# Is it a mount point?
if test "x$install_device" != "x`$grub_mkdevicemap --device-map=/dev/stdout | $grub_probe --target=device --device-map=/dev/stdin ${bootdir}`"; then
efidir=${bootdir}/efi
fi
elif test -n "$rootdir" && test "x$rootdir" != "x/"; then
# The EFI System Partition may have been given directly using
# --root-directory.
install_device=`$grub_mkdevicemap --device-map=/dev/stdout | $grub_probe --target=device --device-map=/dev/stdin ${rootdir}`
# Is it a mount point?
if test "x$install_device" != "x`$grub_mkdevicemap --device-map=/dev/stdout | $grub_probe --target=device --device-map=/dev/stdin ${rootdir}/..`"; then
efidir=${rootdir}
fi
fi
if test -n "$efidir"; then
efi_fs=`$grub_probe --target=fs --device-map=${device_map} ${efidir}`
if test "x$efi_fs" = xfat; then :; else
echo "${efidir} doesn't look like an EFI partition." 1>&2
efidir=
fi
fi
if test -n "$efidir"; then
# The EFI specification requires that an EFI System Partition must
# contain an "EFI" subdirectory, and that OS loaders are stored in
# subdirectories below EFI. Vendors are expected to pick names that do
# not collide with other vendors. To minimise collisions, we use the
# name of our distributor if possible.
2010-09-11 14:37:00 +00:00
efi_distributor="$bootloader_id"
2010-09-08 11:54:38 +00:00
if test $removable = yes; then
# The specification makes stricter requirements of removable
# devices, in order that only one image can be automatically loaded
# from them. The image must always reside under /EFI/BOOT, and it
# must have a specific file name depending on the architecture.
efi_distributor=BOOT
case "$target_cpu" in
i386)
efi_file=BOOTIA32.EFI ;;
x86-64)
efi_file=BOOTX64.EFI ;;
# GRUB does not yet support these architectures, but they're defined
# by the specification so we include them here to ease future
# expansion.
ia64)
efi_file=BOOTIA64.EFI ;;
esac
else
# It is convenient for each architecture to have a different
# efi_file, so that different versions can be installed in parallel.
case "$target_cpu" in
i386)
efi_file=grubia32.efi ;;
x86-64)
efi_file=grubx64.efi ;;
# GRUB does not yet support these architectures, but they're defined
# by the specification so we include them here to ease future
# expansion.
ia64)
efi_file=grubia64.efi ;;
*)
efi_file=grub.efi ;;
esac
# TODO: We should also use efibootmgr, if available, to add a Boot
# entry for ourselves.
fi
efidir="$efidir/EFI/$efi_distributor"
mkdir -p "$efidir" || exit 1
else
# We don't know what's going on. Fall back to traditional
# (non-specification-compliant) behaviour.
efidir="$grubdir"
efi_distributor=
efi_file=grub.efi
fi
fi
2005-07-24 18:16:26 +00:00
# Create the GRUB directory if it is not present.
2010-04-03 18:48:36 +00:00
mkdir -p "$grubdir" || exit 1
2005-07-24 18:16:26 +00:00
# If --recheck is specified, remove the device map, if present.
if test $recheck = yes; then
rm -f $device_map
fi
# Create the device map file if it is not present.
if test -f "$device_map"; then
:
else
# Create a safe temporary file.
test -n "$mklog" && log_file=`$mklog`
$grub_mkdevicemap --device-map=$device_map $no_floppy || exit 1
fi
# Make sure that there is no duplicated entry.
tmp=`sed -n '/^([fh]d[0-9]*)/s/\(^(.*)\).*/\1/p' $device_map \
| sort | uniq -d | sed -n 1p`
if test -n "$tmp"; then
echo "The drive $tmp is defined multiple times in the device map $device_map" 1>&2
exit 1
fi
# Copy the GRUB images to the GRUB directory.
2009-05-02 22:40:21 +00:00
for file in ${grubdir}/*.mod ${grubdir}/*.lst ${grubdir}/*.img ${grubdir}/efiemu??.o; do
2006-09-14 18:52:50 +00:00
if test -f $file && [ "`basename $file`" != menu.lst ]; then
2005-07-24 18:16:26 +00:00
rm -f $file || exit 1
fi
done
2008-11-28 20:06:55 +00:00
for file in ${pkglibdir}/*.mod ${pkglibdir}/*.lst; do
2005-07-24 18:16:26 +00:00
cp -f $file ${grubdir} || exit 1
done
2009-11-25 21:34:35 +00:00
if [ "${target_cpu}-${platform}" = "i386-pc" ] || [ "${target_cpu}-${platform}" = "sparc64-ieee1275" ] ; then
2009-05-02 22:40:21 +00:00
for file in ${pkglibdir}/*.img ${pkglibdir}/efiemu??.o; do
2009-05-03 19:04:59 +00:00
if test -f $file; then
cp -f $file ${grubdir} || exit 1
fi
2008-11-28 20:06:55 +00:00
done
fi
2005-07-24 18:16:26 +00:00
2009-12-05 09:31:36 +00:00
# Copy gettext files
mkdir -p ${grubdir}/locale/
2010-03-21 23:04:02 +00:00
for dir in ${localedir}/*; do
if test -f "$dir/LC_MESSAGES/grub.mo"; then
cp -f "$dir/LC_MESSAGES/grub.mo" "${grubdir}/locale/${dir##*/}.mo"
2009-12-05 09:31:36 +00:00
fi
done
2008-06-06 15:49:23 +00:00
# Write device to a variable so we don't have to traverse /dev every time.
2010-04-03 18:52:06 +00:00
grub_device=`$grub_probe --target=device ${grubdir}` || exit 1
2008-06-06 15:49:23 +00:00
2009-11-20 08:41:20 +00:00
if ! test -f ${grubdir}/grubenv; then
$grub_editenv ${grubdir}/grubenv create
fi
2006-09-14 18:52:50 +00:00
# Create the core image. First, auto-detect the filesystem module.
2008-06-06 15:49:23 +00:00
fs_module=`$grub_probe --target=fs --device ${grub_device}`
2005-08-07 14:59:56 +00:00
if test "x$fs_module" = x -a "x$modules" = x; then
echo "Auto-detection of a filesystem module failed." 1>&2
2006-01-25 00:11:36 +00:00
echo "Please specify the module with the option \`--modules' explicitly." 1>&2
2005-08-07 14:59:56 +00:00
exit 1
fi
2007-07-02 13:58:03 +00:00
# Then the partition map module. In order to support partition-less media,
2010-09-08 21:41:27 +00:00
# this command is allowed to fail.
2010-02-06 18:33:53 +00:00
partmap_module=
for x in `$grub_probe --target=partmap --device ${grub_device} 2> /dev/null`; do
partmap_module="$partmap_module part_$x";
done
2007-05-07 19:54:46 +00:00
2008-01-12 15:11:57 +00:00
# Device abstraction module, if any (lvm, raid).
2008-06-06 15:49:23 +00:00
devabstraction_module=`$grub_probe --target=abstraction --device ${grub_device}`
2008-01-12 15:11:57 +00:00
2008-07-30 10:44:38 +00:00
# The order in this list is critical. Be careful when modifying it.
2009-06-08 20:51:16 +00:00
modules="$modules $disk_module"
2008-11-28 20:06:55 +00:00
modules="$modules $fs_module $partmap_module $devabstraction_module"
2008-07-30 10:44:38 +00:00
2009-11-25 21:34:35 +00:00
relative_grubdir=`make_system_path_relative_to_its_root ${grubdir}` || exit 1
if [ "x${relative_grubdir}" = "x" ] ; then
relative_grubdir=/
fi
2008-07-30 10:44:38 +00:00
prefix_drive=
2009-11-25 21:34:35 +00:00
config_opt=
2010-06-28 08:06:41 +00:00
rm -f ${grubdir}/load.cfg
if [ "x${debug_image}" != x ]; then
echo "set debug='${debug_image}'" >> ${grubdir}/load.cfg
config_opt="-c ${grubdir}/load.cfg "
fi
2008-06-18 17:35:26 +00:00
if [ "x${devabstraction_module}" = "x" ] ; then
2009-12-09 18:39:21 +00:00
if [ x"${install_device}" != x ]; then
if echo "${install_device}" | grep -qx "(.*)" ; then
install_drive="${install_device}"
else
2010-04-03 18:52:06 +00:00
install_drive="`$grub_probe --target=drive --device ${install_device}`" || exit 1
2009-12-09 18:39:21 +00:00
fi
2010-06-13 00:36:39 +00:00
install_drive="`echo ${install_drive} | sed -e s/,[a-z0-9,]*//g`"
2008-07-30 10:44:38 +00:00
fi
2010-04-03 18:52:06 +00:00
grub_drive="`$grub_probe --target=drive --device ${grub_device}`" || exit 1
2008-07-30 10:44:38 +00:00
# Strip partition number
2010-09-08 13:11:45 +00:00
grub_partition="`echo ${grub_drive} | sed -e 's/^[^,]*,//; s/)$//'`"
2010-06-13 00:36:39 +00:00
grub_drive="`echo ${grub_drive} | sed -e s/,[a-z0-9,]*//g`"
2009-06-08 20:51:16 +00:00
if [ "$disk_module" = ata ] ; then
# generic method (used on coreboot and ata mod)
2008-11-28 20:06:55 +00:00
uuid="`$grub_probe --target=fs_uuid --device ${grub_device}`"
if [ "x${uuid}" = "x" ] ; then
2009-06-09 13:22:31 +00:00
echo "UUID needed with ata mod, but the filesystem containing ${grubdir} does not support UUIDs." 1>&2
2008-11-28 20:06:55 +00:00
exit 1
fi
2010-06-28 08:06:41 +00:00
echo "search.fs_uuid ${uuid} root " >> ${grubdir}/load.cfg
2009-11-25 21:34:35 +00:00
echo 'set prefix=($root)'"${relative_grubdir}" >> ${grubdir}/load.cfg
config_opt="-c ${grubdir}/load.cfg "
2009-09-22 07:38:12 +00:00
modules="$modules search_fs_uuid"
2008-11-28 20:06:55 +00:00
elif [ "x${grub_drive}" != "x${install_drive}" ] ; then
2008-07-30 10:44:38 +00:00
uuid="`$grub_probe --target=fs_uuid --device ${grub_device}`"
if [ "x${uuid}" = "x" ] ; then
echo "You attempted a cross-disk install, but the filesystem containing ${grubdir} does not support UUIDs." 1>&2
exit 1
fi
2010-06-28 08:06:41 +00:00
echo "search.fs_uuid ${uuid} root " >> ${grubdir}/load.cfg
2009-11-25 21:34:35 +00:00
echo 'set prefix=($root)'"${relative_grubdir}" >> ${grubdir}/load.cfg
config_opt="-c ${grubdir}/load.cfg "
2009-09-22 07:38:12 +00:00
modules="$modules search_fs_uuid"
2010-09-11 15:21:48 +00:00
elif [ "x$platform" = xefi ] || [ "x$platform" = xpc ]; then
# we need to hardcode the partition number in the core image's prefix.
2010-09-08 13:11:45 +00:00
prefix_drive="(,$grub_partition)"
2008-07-30 10:44:38 +00:00
fi
2008-06-18 17:35:26 +00:00
else
2010-04-03 18:52:06 +00:00
prefix_drive=`$grub_probe --target=drive --device ${grub_device}` || exit 1
2008-06-18 17:35:26 +00:00
fi
2010-05-18 11:45:25 +00:00
case "${target_cpu}-${platform}" in
2010-04-26 19:27:41 +00:00
sparc64-ieee1275) mkimage_target=sparc64-ieee1275-raw ;;
mips-yeeloong) mkimage_target=mipsel-yeeloong-elf ;;
2010-08-30 18:27:59 +00:00
*) mkimage_target="${target_cpu}-${platform}" ;;
2010-04-26 19:27:41 +00:00
esac
2010-08-30 18:27:59 +00:00
case "${target_cpu}-${platform}" in
i386-efi | x86_64-efi) imgext=efi ;;
mips-yeeloong | i386-coreboot | i386-multiboot | i386-ieee1275 \
2010-09-06 21:03:25 +00:00
| powerpc-ieee1275) imgext=elf ;;
2010-08-30 18:27:59 +00:00
*) imgext=img ;;
esac
$grub_mkimage ${config_opt} -O ${mkimage_target} --output=${grubdir}/core.${imgext} --prefix=${prefix_drive}${relative_grubdir} $modules || exit 1
2010-08-30 17:30:34 +00:00
2010-08-30 18:27:59 +00:00
# Backward-compatibility kludges
2010-08-30 17:30:34 +00:00
if [ "${target_cpu}-${platform}" = "mips-yeeloong" ]; then
2010-08-30 18:27:59 +00:00
cp ${grubdir}/core.${imgext} /boot/grub.elf
2010-08-30 17:30:34 +00:00
elif [ "${target_cpu}-${platform}" = "i386-ieee1275" ] || [ "${target_cpu}-${platform}" = "powerpc-ieee1275" ]; then
2010-09-06 21:03:25 +00:00
cp ${grubdir}/core.${imgext} /boot/grub/grub
2010-08-30 18:27:59 +00:00
elif [ "${target_cpu}-${platform}" = "i386-efi" ] || [ "${target_cpu}-${platform}" = "x86_64-efi" ]; then
$grub_mkimage ${config_opt} -O ${mkimage_target} --output=${grubdir}/grub.efi --prefix="" $modules || exit 1
2010-08-30 17:30:34 +00:00
fi
2005-07-24 18:16:26 +00:00
2010-09-08 21:41:27 +00:00
# Verify readability of a few critical files
2010-09-11 15:28:46 +00:00
for file in grubenv normal.mod core.${imgext} ; do
2010-09-08 21:35:53 +00:00
if is_path_readable_by_grub ${grubdir}/${file} ${grub_device} ${relative_grubdir}/${file} ; then : ; else
echo "GRUB is unable to read ${grubdir}/${file}" >&2
exit 1
fi
2010-09-08 21:41:27 +00:00
done
2010-08-30 18:27:59 +00:00
# Perform the platform-dependent install
2010-08-30 17:30:34 +00:00
if [ "${target_cpu}-${platform}" = "i386-pc" ] || [ "${target_cpu}-${platform}" = "sparc64-ieee1275" ] ; then
2008-11-28 20:06:55 +00:00
# Now perform the installation.
2010-08-30 18:27:59 +00:00
$grub_setup ${setup_verbose} ${setup_force} --directory=${grubdir} \
--device-map=${device_map} ${install_device} || exit 1
2010-08-30 17:30:34 +00:00
elif [ "${target_cpu}-${platform}" = "i386-ieee1275" ] || [ "${target_cpu}-${platform}" = "powerpc-ieee1275" ]; then
if [ x"$update_nvram" = xyes ]; then
set $ofpathname dummy
if test -f "$1"; then
:
else
echo "$1: Not found." 1>&2
exit 1
fi
set $nvsetenv dummy
if test -f "$1"; then
:
else
echo "$1: Not found." 1>&2
exit 1
fi
# Get the Open Firmware device tree path translation.
dev=`echo $grub_device | sed -e 's/\/dev\///' -e 's/[0-9]\+//'`
partno=`echo $grub_device | sed -e 's/.*[^0-9]\([0-9]\+\)$/\1/'`
ofpath=`$ofpathname $dev` || {
echo "Couldn't find Open Firmware device tree path for $dev."
echo "You will have to set boot-device manually."
exit 1
}
# Point boot-device at the new grub install
2010-09-06 21:03:25 +00:00
boot_device="$ofpath:$partno,"`grub-mkrelpath ${grubdir}/core.${imgext} | sed 's,/,\\\\,g'`
2010-08-30 17:30:34 +00:00
"$nvsetenv" boot-device "$boot_device" || {
echo "$nvsetenv failed."
echo "You will have to set boot-device manually. At the Open Firmware prompt, type:"
echo " setenv boot-device $boot_device"
exit 1
}
fi
2010-08-30 19:00:48 +00:00
elif [ x"$platform" = xefi ]; then
cp ${grubdir}/core.${imgext} ${efidir}/${efi_file}
2010-09-08 11:54:38 +00:00
2010-08-30 19:00:48 +00:00
# Try to make this image bootable using the EFI Boot Manager, if available.
if test "$removable" = no && test -n "$efi_distributor" && \
test -n "$efibootmgr"; then
# On Linux, we need the efivars kernel modules.
case "$host_os" in
linux*)
modprobe -q efivars 2>/dev/null || true ;;
esac
# Delete old entries from the same distributor.
for bootnum in `efibootmgr | grep '^Boot[0-9]' | \
2010-09-08 12:07:21 +00:00
fgrep -i " $efi_distributor" | cut -b5-8`; do
2010-08-30 19:00:48 +00:00
efibootmgr $efi_quiet -b "$bootnum" -B
done
# Add a new entry for the image we just created. efibootmgr needs to be
# given the disk device and partition number separately, so we have to
# fiddle about with grub-probe to get hold of this reasonably reliably.
# Use fresh device map text to avoid any problems with stale data, since
# all we need here is a one-to-one mapping.
clean_devmap="$($grub_mkdevicemap --device-map=/dev/stdout)"
efidir_drive="$(echo "$clean_devmap" | $grub_probe --target=drive --device-map=/dev/stdin "$efidir")"
if test -z "$efidir_drive"; then
echo "Can't find GRUB drive for $efidir; unable to create EFI Boot Manager entry." >&2
else
efidir_disk="$(echo "$clean_devmap" | grep "^$(echo "$efidir_drive" | sed 's/,[^)]*//')" | cut -f2)"
efidir_part="$(echo "$efidir_drive" | sed 's/^([^,]*,[^0-9]*//; s/[^0-9].*//')"
efibootmgr $efi_quiet -c -d "$efidir_disk" -p "$efidir_part" -w \
-L "$GRUB_DISTRIBUTOR" -l "\\EFI\\$efi_distributor\\$efi_file"
fi
fi
2008-11-28 20:06:55 +00:00
fi
2005-07-24 18:16:26 +00:00
echo "Installation finished. No error reported."
# Bye.
exit 0